Index: /trunk/about.php
===================================================================
--- /trunk/about.php	(revision 606)
+++ /trunk/about.php	(revision 607)
@@ -40,5 +40,6 @@
 	'PAGE_TITLE' => $title,
 	'L_ABOUT' => $lang['about_message'],
-	'L_RETURN' =>  $lang['return_main_page'], 
+	'L_RETURN' =>  $lang['home'],
+	'L_RETURN_HINT' =>  $lang['home_hint'],  
 	'U_RETURN' => add_session_id(PHPWG_ROOT_PATH.'category.php?'.$_SERVER['QUERY_STRING'])
 	)
Index: /trunk/admin.php
===================================================================
--- /trunk/admin.php	(revision 606)
+++ /trunk/admin.php	(revision 607)
@@ -174,5 +174,5 @@
   'L_TITLE'=>$lang['admin_panel'],
   'L_LINKS'=>$lang['links'],
-  'L_GALLERY_INDEX'=>$lang['gallery_index'],
+  'L_GALLERY_INDEX'=>$lang['home'],
   'L_GENERAL'=>$lang['general'],
   'L_DEFAULT'=>$lang['gallery_default'],
Index: /trunk/admin/cat_list.php
===================================================================
--- /trunk/admin/cat_list.php	(revision 606)
+++ /trunk/admin/cat_list.php	(revision 607)
@@ -37,5 +37,5 @@
 $infos = array();
 $categories = array();
-$navigation = $lang['gallery_index'];
+$navigation = $lang['home'];
 // +-----------------------------------------------------------------------+
 // |                    virtual categories management                      |
@@ -137,5 +137,5 @@
   
   $navigation = '<a class="" href="'.add_session_id($base_url).'">';
-  $navigation.= $lang['gallery_index'];
+  $navigation.= $lang['home'];
   $navigation.= '</a>';
   $navigation.= $separator;
Index: /trunk/admin/cat_modify.php
===================================================================
--- /trunk/admin/cat_modify.php	(revision 606)
+++ /trunk/admin/cat_modify.php	(revision 607)
@@ -126,5 +126,5 @@
 $url = PHPWG_ROOT_PATH.'admin.php?page=cat_list&amp;parent_id=';
 $navigation = '<a class="" href="'.add_session_id(PHPWG_ROOT_PATH.'admin.php?page=cat_list').'">';
-$navigation.= $lang['gallery_index'].'</a>-&gt;';
+$navigation.= $lang['home'].'</a>-&gt;';
 $navigation.= get_cat_display_name($current_category['name'], '-&gt;', $url);
 
Index: /trunk/comments.php
===================================================================
--- /trunk/comments.php	(revision 606)
+++ /trunk/comments.php	(revision 607)
@@ -80,5 +80,6 @@
     'L_COMMENT_TITLE' => $title,
     'L_COMMENT_STATS' => $lang['stats_last_days'],
-    'L_COMMENT_RETURN' => $lang['return_main_page'],
+    'L_COMMENT_RETURN' => $lang['home'],
+	'L_COMMENT_RETURN_HINT' => $lang['home_hint'],
     'L_DELETE' =>$lang['delete'],
     'L_VALIDATE'=>$lang['submit'],
Index: /trunk/language/en_UK.iso-8859-1/common.lang.php
===================================================================
--- /trunk/language/en_UK.iso-8859-1/common.lang.php	(revision 606)
+++ /trunk/language/en_UK.iso-8859-1/common.lang.php	(revision 607)
@@ -34,5 +34,4 @@
 
 // Main words 
-$lang['gallery_index'] = 'Home';
 $lang['category'] = 'Category';
 $lang['categories'] = 'Categories';
@@ -68,5 +67,21 @@
 
 // Navigation
-$lang['return_main_page'] = 'Back to the index page';
+$lang['home'] = 'Home';
+$lang['home_hint'] = 'Back to the home page';
+$lang['special_categories'] = 'Specials';
+$lang['favorite_cat'] = 'my favorites';
+$lang['favorite_cat_hint'] = 'display my favorites pictures';
+$lang['most_visited_cat'] = 'most visited';
+$lang['most_visited_cat_hint'] = 'displays most visited pictures';
+$lang['best_rated_cat'] = 'best rated';
+$lang['best_rated_cat_hint'] = 'displays best rated items';
+$lang['recent_pics_cat'] = 'Last pictures';
+$lang['recent_pics_cat_hint'] = 'Displays most recent pictures';
+$lang['recent_cats_cat'] = 'Last categories';
+$lang['recent_cats_cat_hint'] = 'Displays recently updated categories';
+$lang['about'] = 'about';
+$lang['hint_about'] = 'more informations on PhpWebGallery...';
+$lang['admin'] = 'Administration';
+$lang['hint_admin'] = 'available for administrators only';
 
 // Identification
@@ -166,10 +181,5 @@
 $lang['hint_customize'] = 'customize the appareance of the gallery';
 $lang['hint_search'] = 'search';
-$lang['favorite_cat'] = 'my favorites';
-$lang['favorite_cat_hint'] = 'display my favorites pictures';
-$lang['about'] = 'about';
-$lang['hint_about'] = 'more informations on PhpWebGallery...';
-$lang['admin'] = 'Administration';
-$lang['hint_admin'] = 'available for administrators only';
+
 $lang['no_category'] = 'Home';
 $lang['page_number'] = 'page number';
@@ -250,13 +260,6 @@
 $lang['infos_title'] = 'Informations';
 $lang['category_representative'] = 'representative';
-$lang['special_categories'] = 'specials';
-$lang['most_visited_cat_hint'] = 'displays most visited pictures';
-$lang['most_visited_cat'] = 'most visited';
-$lang['best_rated_cat'] = 'best rated';
-$lang['best_rated_cat_hint'] = 'displays best rated items';
-$lang['recent_pics_cat_hint'] = 'Displays most recent pictures';
-$lang['recent_pics_cat'] = 'Last pictures';
-$lang['recent_cats_cat_hint'] = 'Displays recently updated categories';
-$lang['recent_cats_cat'] = 'Last categories';
+
+
 $lang['visited'] = 'visited';
 $lang['times'] = 'times';
@@ -301,5 +304,3 @@
 $lang['random_cat_hint'] = 'Displays a set of random pictures';
 $lang['picture_high'] = 'Click on the picture to see it in high definition';
-$lang['up_hint'] = 'Up to the thumbnails';
-$lang['up_alt'] = 'up';
 ?>
Index: /trunk/language/fr_FR.iso-8859-1/common.lang.php
===================================================================
--- /trunk/language/fr_FR.iso-8859-1/common.lang.php	(revision 606)
+++ /trunk/language/fr_FR.iso-8859-1/common.lang.php	(revision 607)
@@ -34,5 +34,4 @@
 
 // Main words 
-$lang['gallery_index'] = 'Accueil';
 $lang['category'] = 'Catégorie';
 $lang['categories'] = 'Catégories';
@@ -75,14 +74,23 @@
 
 // Navigation
-$lang['special_categories'] = 'Special';
+$lang['home'] = 'Accueil';
+$lang['home_hint'] = 'Retour à la page des miniatures';
+$lang['special_categories'] = 'Spécial';
 $lang['favorite_cat'] = 'Favoris';
 $lang['favorite_cat_hint'] = 'Afficher vos favoris';
+$lang['most_visited_cat'] = 'plus vues';
+$lang['most_visited_cat_hint'] = 'affiche les images les plus visitées';
+$lang['best_rated_cat'] = 'mieux notées';
+$lang['best_rated_cat_hint'] = 'affiche les images les mieux notées';
+$lang['recent_pics_cat'] = 'Nouvelles images';
 $lang['recent_pics_cat_hint'] = 'Affiche les images les plus récentes';
-$lang['recent_pics_cat'] = 'Nouvelles images';
+$lang['recent_cats_cat'] = 'Nouvelles catégories';
 $lang['recent_cats_cat_hint'] = 'Affiche les catégories les plus récentes';
-$lang['recent_cats_cat'] = 'Nouvelles catégories';
 $lang['random_cat'] = 'Images au hasard';
 $lang['random_cat_hint'] = 'Affiche plusieurs images choisies au hasard';
-$lang['return_main_page'] = 'Retour à la page des miniatures';
+$lang['about'] = 'A propos';
+$lang['hint_about'] = 'Quelques informations sur PhpWebGallery...';
+$lang['admin'] = 'Administration';
+$lang['hint_admin'] = 'Partie accessible uniquement aux administrateurs';
 
 //Calendar
@@ -156,5 +164,4 @@
 $lang['search_title'] = 'Recherche';
 $lang['search_field_search'] = 'Rechercher';
-$lang['search_return_main_page'] = 'Retour à la page des miniatures';
 $lang['Search_author_explain'] = 'Utilisez * comme un joker pour des recherches partielles';
 $lang['Look_up_user'] = 'Rechercher l\'utilisateur';
@@ -177,8 +184,5 @@
 $lang['hint_search'] = 'lancer une recherche';
 
-$lang['about'] = 'à propos';
-$lang['hint_about'] = 'des infos sur PhpWebGallery...';
-$lang['admin'] = 'Administration';
-$lang['hint_admin'] = 'accessible uniquement aux administrateurs';
+
 $lang['no_category'] = 'Accueil';
 $lang['page_number'] = 'numéro de page';
@@ -261,8 +265,5 @@
 $lang['connected_user'] = 'utilisateur connecté';
 $lang['hint_comments'] = 'Voir les derniers commentaires des visiteurs';
-$lang['most_visited_cat_hint'] = 'affiche les images les plus visitées';
-$lang['most_visited_cat'] = 'plus vues';
-$lang['best_rated_cat_hint'] = 'affiche les images les mieux notées';
-$lang['best_rated_cat'] = 'mieux notées';
+
 
 $lang['visited'] = 'visité';
Index: /trunk/picture.php
===================================================================
--- /trunk/picture.php	(revision 606)
+++ /trunk/picture.php	(revision 607)
@@ -444,5 +444,5 @@
   'HEIGHT_IMG' => $picture_size[1],
 
-  'L_HOME' => $lang['gallery_index'],
+  'L_HOME' => $lang['home'],
   'L_SLIDESHOW' => $lang['slideshow'],
   'L_STOP_SLIDESHOW' => $lang['slideshow_stop'],
@@ -460,6 +460,6 @@
   'L_PICTURE_METADATA' => $lang['picture_show_metadata'],
   'L_PICTURE_HIGH' => $lang['picture_high'],
-  'L_UP_HINT' => $lang['up_hint'],
-  'L_UP_ALT' => $lang['up_alt'],
+  'L_UP_HINT' => $lang['home_hint'],
+  'L_UP_ALT' => $lang['home'],
   
   'U_HOME' => add_session_id(PHPWG_ROOT_PATH.'category.php'),
Index: /trunk/search.php
===================================================================
--- /trunk/search.php	(revision 606)
+++ /trunk/search.php	(revision 607)
@@ -237,5 +237,5 @@
   'L_TITLE' => $lang['search_title'],
   'L_SEARCH_COMMENTS' => $lang['search_comments'],
-  'L_RETURN' => $lang['gallery_index'],
+  'L_RETURN' => $lang['home'],
   'L_SUBMIT' => $lang['submit'],
   'L_SEARCH_OR'=>$lang['search_mode_or'],
Index: /trunk/template/default/about.tpl
===================================================================
--- /trunk/template/default/about.tpl	(revision 606)
+++ /trunk/template/default/about.tpl	(revision 607)
@@ -4,5 +4,5 @@
 </div>
 <div style="text-align:center;margin:5px;">
-<a href="{U_RETURN}">{L_RETURN}</a>
+<a href="{U_RETURN}" title="{L_RETURN_HINT}">[{L_RETURN}]</a>
 </div>
 <div style="text-align:center;margin:5px;">
Index: /trunk/template/default/comments.tpl
===================================================================
--- /trunk/template/default/comments.tpl	(revision 606)
+++ /trunk/template/default/comments.tpl	(revision 607)
@@ -10,5 +10,5 @@
       ]
 	  <!-- BEGIN title -->
-      [ <a class="admin" href="{U_HOME}">{L_COMMENT_RETURN}</a> ]
+      [ <a class="admin" href="{U_HOME}" title="{L_COMMENT_RETURN_HINT}">{L_COMMENT_RETURN}</a> ]
 	  <!-- END title -->
 </div>
Index: /trunk/template/default/search.tpl
===================================================================
--- /trunk/template/default/search.tpl	(revision 606)
+++ /trunk/template/default/search.tpl	(revision 607)
@@ -116,3 +116,3 @@
 <input class="radio" type="radio" name="mode" value="AND" {AND_CHECKED} /> {L_SEARCH_AND_CLAUSES}<br /><br />
 <input type="submit" name="submit" value="{L_SUBMIT}" class="bouton" /><br /><br />
-<a href="{U_HOME}">[ {L_RETURN} ]</a>
+<a href="{U_HOME}" title="{L_RETURN_HINT}">[ {L_RETURN} ]</a>
Index: /trunk/upload.php
===================================================================
--- /trunk/upload.php	(revision 606)
+++ /trunk/upload.php	(revision 607)
@@ -302,5 +302,6 @@
   'L_CREATION_DATE' =>  $lang['upload_creation_date'], 
   'L_COMMENT' =>  $lang['upload_comment'],
-  'L_RETURN' =>  $lang['search_return_main_page'],
+  'L_RETURN' =>  $lang['home'],
+  'L_RETURN_HINT' =>  $lang['home_hint'],
   'L_UPLOAD_DONE' =>  $lang['upload_successful'],
   'L_MANDATORY' =>  $lang['mandatory'],