Index: /trunk/admin.php
===================================================================
--- /trunk/admin.php	(revision 621)
+++ /trunk/admin.php	(revision 622)
@@ -200,8 +200,8 @@
   'L_AUTH'=>$lang['permissions'],
   'L_UPDATE'=>$lang['update'],
-  'L_CAT_UPLOAD'=>$lang['cat_options_upload_menu'],
-  'L_CAT_COMMENTS'=>$lang['cat_options_comments_menu'],
-  'L_CAT_VISIBLE'=>$lang['cat_options_visible_menu'],
-  'L_CAT_STATUS'=>$lang['cat_options_status_menu'],
+  'L_CAT_UPLOAD'=>$lang['upload'],
+  'L_CAT_COMMENTS'=>$lang['comments'],
+  'L_CAT_VISIBLE'=>$lang['lock'],
+  'L_CAT_STATUS'=>$lang['permissions'],
 
   'U_CONFIG_GENERAL'=>add_session_id($conf_link.'general' ),
Index: /trunk/admin/cat_list.php
===================================================================
--- /trunk/admin/cat_list.php	(revision 621)
+++ /trunk/admin/cat_list.php	(revision 622)
@@ -283,6 +283,6 @@
   'L_STORAGE'=>$lang['storage'],
   'L_NB_IMG'=>$lang['pictures'],
-  'L_MOVE_UP'=>$lang['cat_up'],
-  'L_MOVE_DOWN'=>$lang['cat_down'],
+  'L_MOVE_UP'=>$lang['up'],
+  'L_MOVE_DOWN'=>$lang['down'],
   'L_EDIT'=>$lang['edit'],
   'L_INFO_IMG'=>$lang['cat_image_info'],
Index: /trunk/admin/cat_modify.php
===================================================================
--- /trunk/admin/cat_modify.php	(revision 621)
+++ /trunk/admin/cat_modify.php	(revision 622)
@@ -152,5 +152,5 @@
   'L_ACCESS_FREE'=>$lang['free'],
   'L_ACCESS_RESTRICTED'=>$lang['restricted'],
-  'L_EDIT_LOCK'=>$lang['cat_lock'],
+  'L_EDIT_LOCK'=>$lang['lock'],
   'L_EDIT_LOCK_INFO'=>$lang['cat_lock_info'],
   'L_YES'=>$lang['yes'],
Index: /trunk/admin/cat_options.php
===================================================================
--- /trunk/admin/cat_options.php	(revision 621)
+++ /trunk/admin/cat_options.php	(revision 622)
@@ -183,9 +183,4 @@
     'L_RESET'=>$lang['reset'],
     
-    'U_UPLOAD'=>add_session_id($base_url.'upload'),
-    'U_VISIBLE'=>add_session_id($base_url.'visible'),
-    'U_COMMENTS'=>add_session_id($base_url.'comments'),
-    'U_STATUS'=>add_session_id($base_url.'status'),
-    
     'F_ACTION'=>add_session_id($base_url.$page['section'])
    )
@@ -228,8 +223,8 @@
     $template->assign_vars(
       array(
-        'L_TITLE' => $lang['cat_options_upload_title'],
-        'L_CAT_OPTIONS_TRUE' => $lang['cat_options_upload_true'],
-        'L_CAT_OPTIONS_FALSE' => $lang['cat_options_upload_false'],
-        'L_CAT_OPTIONS_INFO' => $lang['cat_options_upload_info'],
+        'L_CAT_TITLE' => $lang['cat_upload_title'],
+        'L_CAT_OPTIONS_TRUE' => $lang['authorized'],
+        'L_CAT_OPTIONS_FALSE' => $lang['forbidden'],
+        'L_CAT_OPTIONS_INFO' => $lang['cat_upload_info'],
         )
       );
@@ -251,8 +246,8 @@
     $template->assign_vars(
       array(
-        'L_TITLE' => $lang['cat_options_comments_title'],
-        'L_CAT_OPTIONS_TRUE' => $lang['cat_options_comments_true'],
-        'L_CAT_OPTIONS_FALSE' => $lang['cat_options_comments_false'],
-        'L_CAT_OPTIONS_INFO' => $lang['cat_options_comments_info'],
+        'L_CAT_TITLE' => $lang['cat_comments_title'],
+        'L_CAT_OPTIONS_TRUE' => $lang['authorized'],
+        'L_CAT_OPTIONS_FALSE' => $lang['forbidden'],
+        'L_CAT_OPTIONS_INFO' => $lang['cat_comments_info'],
         )
       );
@@ -274,8 +269,8 @@
     $template->assign_vars(
       array(
-        'L_TITLE' => $lang['cat_options_visible_title'],
-        'L_CAT_OPTIONS_TRUE' => $lang['cat_options_visible_true'],
-        'L_CAT_OPTIONS_FALSE' => $lang['cat_options_visible_false'],
-        'L_CAT_OPTIONS_INFO' => $lang['cat_options_visible_info'],
+        'L_CAT_TITLE' => $lang['cat_lock_title'],
+        'L_CAT_OPTIONS_TRUE' => $lang['lock'],
+        'L_CAT_OPTIONS_FALSE' => $lang['unlock'],
+        'L_CAT_OPTIONS_INFO' => $lang['cat_lock_info'],
         )
       );
@@ -297,8 +292,8 @@
     $template->assign_vars(
       array(
-        'L_TITLE' => $lang['cat_options_status_title'],
-        'L_CAT_OPTIONS_TRUE' => $lang['cat_options_status_true'],
-        'L_CAT_OPTIONS_FALSE' => $lang['cat_options_status_false'],
-        'L_CAT_OPTIONS_INFO' => $lang['cat_options_status_info'],
+        'L_CAT_TITLE' => $lang['cat_status_title'],
+        'L_CAT_OPTIONS_TRUE' => $lang['cat_public'],
+        'L_CAT_OPTIONS_FALSE' => $lang['cat_private'],
+        'L_CAT_OPTIONS_INFO' => $lang['cat_status_info'],
         )
       );
Index: /trunk/language/en_UK.iso-8859-1/admin.lang.php
===================================================================
--- /trunk/language/en_UK.iso-8859-1/admin.lang.php	(revision 621)
+++ /trunk/language/en_UK.iso-8859-1/admin.lang.php	(revision 622)
@@ -46,4 +46,8 @@
 $lang['metadata']='Metadata';
 $lang['visitors'] = 'Visitors';
+$lang['lock'] = 'Lock';
+$lang['unlock'] = 'Unlock';
+$lang['up'] = 'Move up';
+$lang['down'] = 'Move down';
 
 // Specific words
@@ -78,6 +82,4 @@
 
 // Categories
-$lang['cat_up'] = 'Move up';
-$lang['cat_down'] = 'Move down';
 $lang['cat_add'] = 'Add a virtual category';
 $lang['cat_virtual'] = 'Virtual category';
@@ -88,11 +90,17 @@
 $lang['editcat_confirm'] = 'Category informations updated successfully.';
 $lang['editcat_perm'] = 'To set permissions for this category, click';
-$lang['cat_upload'] = 'Select uploadable categories';
-$lang['cat_upload_info'] = 'Only non virtual categories are shown.';
-$lang['cat_lock'] = 'Lock';
-$lang['cat_lock_info'] = 'This category will temporary been disabled for maintenance.';
 $lang['cat_access_info'] = 'Permission management.';
 $lang['cat_virtual_added'] = 'Virtual category added';
 $lang['cat_virtual_deleted'] = 'Virtual category deleted';
+$lang['cat_upload_title'] = 'Select uploadable categories';
+$lang['cat_upload_info'] = 'Only non virtual and non remote categories are shown.';
+$lang['cat_lock_title'] = 'Lock categories';
+$lang['cat_lock_info'] = 'Selected categories will temporary been disabled for maintenance.';
+$lang['cat_comments_title'] = 'Authorize users to add comments on selected categories';
+$lang['cat_comments_info'] = 'By inheritance, an element is commentable if it belongs at least to one commentable category.';
+$lang['cat_status_title'] = 'Manage authorizations for selected categories';
+$lang['cat_status_info'] = 'Selected categories are private : you will need to authorize users and/or groups to access to them.
+<br />If you make a category private, all its child categories becomes private.
+<br />It you make a category public, all its parent categories becomes public';
 
 // Titles
@@ -325,25 +333,3 @@
 $lang['cat_list_virtual_category_added'] = 'virtual category added';
 $lang['cat_list_virtual_category_deleted'] = 'virtual category deleted';
-
-$lang['cat_options_menu'] = 'Options';
-$lang['cat_options_upload_menu'] = 'Upload';
-$lang['cat_options_upload_title'] = 'upload authorization settings for categories';
-$lang['cat_options_visible_menu'] = 'Lock';
-$lang['cat_options_visible_title'] = 'temporary lock categories';
-$lang['cat_options_comments_menu'] = 'Comments';
-$lang['cat_options_comments_title'] = 'authorize comments for categories';
-$lang['cat_options_status_menu'] = 'Access';
-$lang['cat_options_status_title'] = 'make your category private or public';
-$lang['cat_options_upload_true'] = 'upload authorized';
-$lang['cat_options_upload_false'] = 'upload forbidden';
-$lang['cat_options_upload_info'] = '(multi)select categories to make them uploadable or not. Upload is not applicable to virtual categories and to categories from a remote site.';
-$lang['cat_options_comments_true'] = 'comments authorized';
-$lang['cat_options_comments_false'] = 'comments forbidden';
-$lang['cat_options_comments_info'] = '(multi)select categories to make them commentable or not. By inheritance, an element is commentable if it belongs at least to one commentable category.';
-$lang['cat_options_visible_true'] = 'unlocked';
-$lang['cat_options_visible_false'] = 'locked';
-$lang['cat_options_visible_info'] = '(multi)select categories to lock or unlock them. If you lock category,  all its child categories becomes locked. It you unlock a category, all its parent categories becomes unlocked';
-$lang['cat_options_status_true'] = 'public';
-$lang['cat_options_status_false'] = 'private';
-$lang['cat_options_status_info'] = '(multi)select categories to make them public or private. If you make a category private, all its child categories becomes private. It you make a category public, all its parent categories becomes public';
 ?>
Index: /trunk/language/fr_FR.iso-8859-1/admin.lang.php
===================================================================
--- /trunk/language/fr_FR.iso-8859-1/admin.lang.php	(revision 621)
+++ /trunk/language/fr_FR.iso-8859-1/admin.lang.php	(revision 622)
@@ -46,4 +46,9 @@
 $lang['metadata']='Métadonnées';
 $lang['visitors'] = 'Visiteurs';
+$lang['storage'] = 'Répertoire';
+$lang['lock'] = 'Verrouiller';
+$lang['unlock'] = 'Déverrouiller';
+$lang['up'] = 'Monter';
+$lang['down'] = 'Descendre';
 
 // Specific words
@@ -78,7 +83,4 @@
 
 // Category words
-$lang['storage'] = 'Répertoire';
-$lang['cat_up'] = 'Monter';
-$lang['cat_down'] = 'Descendre';
 $lang['cat_add'] = 'Ajouter une catégorie virtuelle';
 $lang['cat_virtual'] = 'Catégorie virtuelle';
@@ -89,28 +91,17 @@
 $lang['editcat_confirm'] = 'Les informations associées à cette catégorie ont été mises à jour.';
 $lang['editcat_perm'] = 'Pour accéder aux permissions associées, cliquez';
-$lang['cat_upload'] = 'Sélectionner les catégories pour lesquelles l\'ajout d\'image est autorisé';
-$lang['cat_upload_info'] = 'Seules les catégories non virtuelles sont repertoriées.';
-$lang['cat_lock'] = 'Verrouiller';
-$lang['cat_lock_info'] = 'Cela rendra la catégorie temporairement invisible pour les utilisateurs (maintenance)';
 $lang['cat_access_info'] = 'Permet de gérer l\'accès à cette catégorie.';
 $lang['cat_virtual_added'] = 'Catégorie virtuelle créée';
 $lang['cat_virtual_deleted'] = 'Catégorie virtuelle détruite';
-$lang['cat_options_menu'] = 'Options';
-$lang['cat_options_menu_upload'] = 'upload';
-$lang['cat_options_menu_visible'] = 'lock';
-$lang['cat_options_menu_comments'] = 'comments';
-$lang['cat_options_menu_status'] = 'access';
-$lang['cat_options_upload_true'] = 'authorize upload';
-$lang['cat_options_upload_false'] = 'forbid upload';
-$lang['cat_options_upload_info'] = '(multi)select categories to make them uploadable or not. Upload is not applicable to virtual categories and to categories from a remote site.';
-$lang['cat_options_comments_true'] = 'authorize comments';
-$lang['cat_options_comments_false'] = 'forbid comments';
-$lang['cat_options_comments_info'] = '(multi)select categories to make them commentable or not. By inheritance, an element is commentable if it belongs at least to one commentable category.';
-$lang['cat_options_visible_true'] = 'unlock';
-$lang['cat_options_visible_false'] = 'lock temporary';
-$lang['cat_options_visible_info'] = '(multi)select categories to lock or unlock them. If you lock category,  all its child categories becomes locked. It you unlock a category, all its parent categories becomes unlocked';
-$lang['cat_options_status_true'] = 'public';
-$lang['cat_options_status_false'] = 'private';
-$lang['cat_options_status_info'] = '(multi)select categories to make them public or private. If you make a category private, all its child categories becomes private. It you make a category public, all its parent categories becomes public';
+$lang['cat_upload_title'] = 'Sélectionner les catégories pour lesquelles l\'ajout d\'image est autorisé';
+$lang['cat_upload_info'] = 'Seules les catégories non virtuelles et non distantes sont repertoriées.';
+$lang['cat_lock_title'] = 'Verrouiller les catégories';
+$lang['cat_lock_info'] = 'Cela rendra la catégorie temporairement invisible pour les utilisateurs (maintenance)';
+$lang['cat_comments_title'] = 'Autoriser les utilisateurs à poster des commentaires';
+$lang['cat_comments_info'] = 'Par héritage, il est possible de poster des commentaires dans une sous-catégorie si cela est autorisé pour au moins une catégorie mère.';
+$lang['cat_status_title'] = 'Gestion des autorisations';
+$lang['cat_status_info'] = 'Les catégories sélectionnées sont privées : vous devrez permettre à vos utilisateurs et / ou groupes d\'y accéder.
+<br />Si une catégorie est déclarée privée, alors toutes ses sous catégories deviennent privées.
+<br />Si une catégorie est déclarée publique, alors toutes les catégories mères deviennent publiques.';
 
 //Titles
@@ -130,4 +121,5 @@
 $lang['title_waiting'] = 'Images en attente de validation';
 $lang['title_upload'] = 'Sélectionner les catégories pour lesquelles l\'ajout d\'image est autorisé';
+$lang['title_cat_options'] = 'Options relatives aux catégories';
 
 //Error messages
Index: /trunk/template/default/admin/cat_options.tpl
===================================================================
--- /trunk/template/default/admin/cat_options.tpl	(revision 621)
+++ /trunk/template/default/admin/cat_options.tpl	(revision 622)
@@ -1,44 +1,30 @@
-<table width="100%" align="center">
-  <tr class="admin">
-    <th colspan="2">{L_TITLE}</th>
-  </tr>
-</table>
-
-<form action="{F_ACTION}" method="post">
-
-  <table>
-    <tr>
-      <td style="text-align:center;">{L_CAT_OPTIONS_TRUE}</td>
-      <td></td>
-      <td style="text-align:center;">{L_CAT_OPTIONS_FALSE}</td>
-    </tr>
-    <tr>
-      <td>
-  <select style="width:300px" multiple="multiple" name="cat_true[]" size="20">
+<div class="admin">{L_CAT_TITLE}</div>
+<form name="form1" method="post" action="{F_ACTION}" style="text-align:center;width:800px;">
+<div style="clear:both;"></div>
+<div style="height:auto;">
+  <div style="float:left;padding:10px;width:300px;">
+  <span class="titreMenu">{L_CAT_OPTIONS_TRUE}</span><br />
+  <select style="height:auto;width:280px" name="cat_true[]" multiple="multiple" size="10">
     <!-- BEGIN category_option_true -->
     <option class="{category_option_true.CLASS}" {category_option_true.SELECTED} value="{category_option_true.VALUE}">{category_option_true.OPTION}</option>
     <!-- END category_option_true -->
   </select>
-      </td>
-      <td valign="middle">
-  <input type="submit" value="&rarr;" name="falsify" style="font-size:15px;" class="bouton" />
-  <br />
-  <input type="submit" value="&larr;" name="trueify" style="font-size:15px;" class="bouton" />
-      </td>
-      <td>
-  <select style="width:300px" multiple="multiple" name="cat_false[]" size="20">
+  </div>
+  <div style="float:left;padding-top:80px;padding-bottom:80px;text-align:center;width:160px;" >
+    <input type="submit" value="&larr;" name="trueify" style="font-size:15px;" class="bouton" /><br/>
+    <input type="submit" value="&rarr;" name="falsify" style="font-size:15px;" class="bouton" />
+  </div>
+  <div style="float:right;padding:10px;width:300px;">
+   <span class="titreMenu">{L_CAT_OPTIONS_FALSE}</span><br />
+  <select style="width:280px" name="cat_false[]" multiple="multiple" size="10">
     <!-- BEGIN category_option_false -->
     <option class="{category_option_false.CLASS}" {category_option_false.SELECTED} value="{category_option_false.VALUE}">{category_option_false.OPTION}</option>
     <!-- END category_option_false -->
   </select>
-      </td>
-    </tr>
-  </table>
+  </div>
+</div>
+<div style="clear:both;"></div>
+<input type="reset" name="reset" value="{L_RESET}" class="bouton" />
+</form>
+<div class="information">{L_CAT_OPTIONS_INFO}</div>
 
-  <p>{L_CAT_OPTIONS_INFO}</p>
-
-  <p style="text-align:center;">
-    <input type="reset" name="reset" value="{L_RESET}" class="bouton" />
-  </p>
-
-</form>
Index: /trunk/template/default/default.css
===================================================================
--- /trunk/template/default/default.css	(revision 621)
+++ /trunk/template/default/default.css	(revision 622)
@@ -51,6 +51,7 @@
 	font:			bold 18pt 'Trebuchet MS', Verdana, sans-serif;
 	text-decoration:none; 
-	line-height:	120%; 
-}
+	line-height:	120%;
+}
+
 h2 {
 	font:			bold 12pt Arial, Helvetica, sans-serif;
@@ -351,6 +352,7 @@
 
 div.information {
-  text-align:center;
-  border:2px solid #E0E0E0;
+  text-align:left;
+  font-size:14px;
+  font-weight:bold;
   margin:10px;
   padding:5px;