Index: trunk/template/default/admin/admin_upload.tpl
===================================================================
--- trunk/template/default/admin/admin_upload.tpl	(revision 622)
+++ 	(revision )
@@ -1,22 +1,0 @@
-<div class="admin">{L_UPLOAD_TITLE}</div>
-<form name="form1" method="post" action="" style="text-align:center;width:80%;">
-<div style="clear:both;"></div>
-  <div style="float:left;padding:10px;">
-  {L_AUTHORIZED}<br />
-  <select style="width:280px" name="cat_data[]" multiple="multiple" size="5">
-    {UPLOADABLE_CATEGORIES}
-  </select><br />
-  <input type="submit" name="delete" value="{L_DELETE}" class="bouton" />
-  </div>
-  <div style="float:right;padding:10px;">
-  {L_FORBIDDEN}<BR />
-  <select style="width:280px" name="cat_data[]" multiple="multiple" size="5">
-    {PRIVATE_CATEGORIES}
-  </select>
-  <br>
-  <input type="submit" name="submit" value="{L_SUBMIT}" class="bouton" /> &nbsp;
-  <input type="reset" name="reset" value="{L_RESET}" class="bouton" />
-  </div>
-<div style="clear:both;"></div>
-</form>
-<div class="infoCat">{L_UPLOAD_INFO}</div>
Index: trunk/template/default/admin/group_list.tpl
===================================================================
--- trunk/template/default/admin/group_list.tpl	(revision 623)
+++ trunk/template/default/admin/group_list.tpl	(revision 623)
@@ -0,0 +1,52 @@
+<!-- BEGIN errors -->
+<div class="errors">
+<ul>
+  <!-- BEGIN error -->
+  <li>{errors.error.ERROR}</li>
+  <!-- END error -->
+</ul>
+</div>
+<!-- END errors -->
+<form method="post" name="post" action="{S_GROUP_ACTION}">
+<div class="admin">{L_GROUP_SELECT}</div>
+<!-- BEGIN select_box -->
+{S_GROUP_SELECT}&nbsp;&nbsp;<input type="submit" name="edit" value="{L_LOOK_UP}" class="bouton" />
+<input type="submit" name="delete" value="{L_GROUP_DELETE}" class="bouton" />
+<div style="vertical-align:middle;">
+<input type="checkbox" name="confirm_delete" value="1">{L_GROUP_CONFIRM}
+</div>
+<!-- END select_box -->
+<input type="text" name="newgroup">
+<input type="submit" class="bouton" name="new" value="{L_CREATE_NEW_GROUP}" />
+<br />
+<br />
+<!-- BEGIN edit_group -->
+<div class="admin">{L_GROUP_EDIT} [{edit_group.GROUP_NAME}]</div>
+<table class="table2" width="60%" style="margin-left:20%;">
+<tr class="throw">
+    <th width="25%">{L_USER_NAME}</th>
+	  <th width="25%">{L_USER_EMAIL}</th>
+    <th width="10%">{L_USER_SELECT}</th>
+</tr>
+<!-- BEGIN user -->
+  <tr class="{edit_group.user.T_CLASS}">
+    <td>{edit_group.user.NAME}</td>
+    <td>{edit_group.user.EMAIL}</td>
+	  <td align="center"><input name="members[]" type="checkbox" value="{edit_group.user.ID}"></td>
+  </tr>
+<!-- END user -->
+<tr>
+  <td colspan="3" align="right" valign="middle">
+    <input type="submit" name="deny_user" value="{L_DENY_SELECTED}" class="bouton" />
+  </td>
+</tr>
+</table>
+<div align="left" style="margin-left:20%;">
+<input type="text" name="username" maxlength="50" size="20" />
+<input type="submit" name="add" value="{L_ADD_MEMBER}" class="bouton" />
+<input name="edit_group_id" type="hidden" value="{edit_group.GROUP_ID}">
+<input type="submit" name="usersubmit" value="{L_FIND_USERNAME}" class="bouton" onClick="window.open('{U_SEARCH_USER}', '_phpbbsearch', 'HEIGHT=250,resizable=yes,WIDTH=400');return false;" />
+</div>
+<br />
+<!-- END edit_group -->
+</form>
Index: trunk/template/default/admin/group_list.vtp
===================================================================
--- trunk/template/default/admin/group_list.vtp	(revision 622)
+++ 	(revision )
@@ -1,53 +1,0 @@
-<!--VTP_errors-->
-<div class="errors">
-  <ul>
-    <!--VTP_li-->
-    <li>{#li}</li>
-    <!--/VTP_li-->
-  </ul>
-</div>
-<!--/VTP_errors-->
-
-<!--VTP_deletion-->
-<table style="width:100%;">
-  <tr>
-    <th colspan="2">{#group_confirm} "{#name}"</th>
-  </tr>
-  <tr>
-    <td align="center"><a href="{#yes_url}">{#yes}</a></td>
-    <td align="center" class="row2"><a href="{#no_url}">{#no}</a></td>
-  </tr>
-</table>
-<!--/VTP_deletion-->
-
-<!--VTP_confirmation-->
-<div class="{#class}">{#info}</div>
-<!--/VTP_confirmation-->
-
-<form method="post" action="{#form_action}">
-  <div style="text-align:center;margin:10px;">
-    {#group_add} <input type="text" name="name" />
-    <input type="submit" value="{#add}" name="submit" />
-  </div>
-</form>
-
-<!--VTP_groups-->
-<table width="100%">
-  <tr>
-    <th colspan="3">{#group_list_title}</th>
-  </tr>
-  <!--VTP_group-->
-  <tr>
-    <td style="width:25%;">
-      <div style="margin-left:10px;color:{#color}"><img src="./template/{#user_template}/admin/images/puce.gif" alt="&gt;" /> {#name}</div>
-    </td>
-    <td class="row2" style="text-align:center;width:25%;">
-      <a href="{#permission_url}">{#listuser_permission}</a>
-    </td>
-    <td class="row2" style="text-align:center;width:25%;">
-      <a href="{#deletion_url}">{#delete}</a>
-    </td>
-  </tr>
-  <!--/VTP_group-->
-</table>
-<!--/VTP_groups-->
Index: trunk/template/default/default.css
===================================================================
--- trunk/template/default/default.css	(revision 622)
+++ trunk/template/default/default.css	(revision 623)
@@ -1,3 +1,4 @@
 /* BACKGROUND */
+
 body { background-color:#000000;}
 .main, .throw, .admin {	background-color:#3F3F3F;}
@@ -9,4 +10,20 @@
 .bouton, .imgMenu a, #imgBarMenu { background-image: url(theme/button_bg.gif);}
 
+/* FONT COLORS */
+
+.titreMenu, .titreMenu a, .info, .admin{ color:#FFF48E;}
+.titrePage, .titreMenu a:hover { color:#E0E0E0;}
+.comment{ color:#C6B78E;}
+.commentDate { color:#999999;}
+input,select,textarea { color:#FFFFCC;}
+
+/* ANCHORS */
+
+a { text-decoration:none; color:#FFFFFF;}
+a:hover { text-decoration:none; color:#FFF48E;}
+a.none:hover { text-decoration:none;}
+a.image:hover { text-decoration:none;}
+a.thumbLink:hover { text-decoration:none;}
+
 /* POSITION */
 #gauche,#droite
@@ -24,18 +41,7 @@
 }
 
-#droite
-{
-  text-align:right;
-}
-
-#left
-{
-  float:left; 
-}
-
-#right
-{
-  float:right; 
-}
+#droite{text-align:right;}
+#left {float:left; }
+#right{float:right; }
 
 /* MAIN STYLES */
@@ -60,11 +66,5 @@
 }
 
-/* ANCHORS */
-
-a { text-decoration:none; color:#FFFFFF;}
-a:hover { text-decoration:none; color:#FFF48E;}
-a.none:hover { text-decoration:none;}
-a.image:hover { text-decoration:none;}
-a.thumbLink:hover { text-decoration:none;}
+
 
 /* LAYOUT STYLE */
@@ -93,5 +93,4 @@
   line-height: 25px;
   font-size:12px;
-  color:#E0E0E0;
   font-weight:600;
   text-align:center;
@@ -266,12 +265,8 @@
   font-weight:lighter;
   text-align:right;
-  color:#999999;
   border-top: 1px solid #000000; 
   border-bottom: 1px solid #000000;
 }
 
-.comment{
-  color:#C6B78E; 
-}
 /* Form styles */
 
@@ -295,5 +290,4 @@
  border: 1px solid #797979;
  padding: 0;
- color:#FFFFCC;
 }
 
@@ -317,10 +311,8 @@
 text-align: center;
 padding:0px;
-color : #FFF48E;
 }
 
 /* Other styles */
 .info {
-  color:#FFF48E;
   margin:5px 0px 5px 0px;
   white-space:nowrap;