Index: trunk/admin/cat_modify.php
===================================================================
--- trunk/admin/cat_modify.php	(revision 648)
+++ trunk/admin/cat_modify.php	(revision 649)
@@ -143,8 +143,8 @@
   
   'L_EDIT_CONFIRM'=>$lang['editcat_confirm'],
-  'L_EDIT_NAME'=>$lang['description'],
+  'L_EDIT_NAME'=>$lang['name'],
   'L_STORAGE'=>$lang['storage'],
   'L_REMOTE_SITE'=>$lang['remote_site'],
-  'L_EDIT_COMMENT'=>$lang['comment'],
+  'L_EDIT_COMMENT'=>$lang['description'],
   'L_EDIT_CAT_OPTIONS'=>$lang['cat_options'],
   'L_EDIT_STATUS'=>$lang['conf_access'],
Index: trunk/admin/configuration.php
===================================================================
--- trunk/admin/configuration.php	(revision 648)
+++ trunk/admin/configuration.php	(revision 649)
@@ -249,4 +249,6 @@
         'L_NB_COMMENTS'=>$lang['show_nb_comments'],
         'L_NB_COMMENTS_INFO'=>$lang['conf_show_nb_comments_info'],
+        'L_MAXWIDTH'=>$lang['maxwidth'],
+        'L_MAXHEIGHT'=>$lang['maxheight'],
   
         'CONF_LANG_SELECT'=>language_select($conf['default_language'], 'default_language'),
Index: trunk/admin/infos_images.php
===================================================================
--- trunk/admin/infos_images.php	(revision 648)
+++ trunk/admin/infos_images.php	(revision 649)
@@ -284,5 +284,5 @@
       'L_THUMBNAIL'=>$lang['thumbnail'],
       'L_INFOS_IMG'=>$lang['infoimage_title'],
-      'L_INFOS_COMMENT'=>$lang['comment'],
+      'L_INFOS_COMMENT'=>$lang['description'],
       'L_INFOS_ASSOCIATE'=>$lang['infoimage_associate'],
       'L_SUBMIT'=>$lang['submit'],
Index: trunk/admin/picture_modify.php
===================================================================
--- trunk/admin/picture_modify.php	(revision 648)
+++ trunk/admin/picture_modify.php	(revision 649)
@@ -197,5 +197,5 @@
   'L_CREATION_DATE'=>$lang['creation_date'],
   'L_KEYWORDS'=>$lang['keywords'],
-  'L_COMMENT'=>$lang['comment'],
+  'L_COMMENT'=>$lang['description'],
   'L_CATEGORIES'=>$lang['categories'],
   'L_DISSOCIATE'=>$lang['dissociate'],
Index: trunk/install/config.sql
===================================================================
--- trunk/install/config.sql	(revision 648)
+++ trunk/install/config.sql	(revision 649)
@@ -5,4 +5,6 @@
 INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('default_language','en_UK.iso-8859-1','Default gallery language');
 INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('default_template','default','Default gallery style');
+INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('default_maxwidth','','maximum width authorized for displaying images');
+INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('default_maxheight','','maximum height authorized for the displaying images');
 INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('access','free','access type to your gallery (free|restricted)');
 INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('nb_comment_page','10','number of comments to display on each page');
Index: trunk/language/en_UK.iso-8859-1/common.lang.php
===================================================================
--- trunk/language/en_UK.iso-8859-1/common.lang.php	(revision 648)
+++ trunk/language/en_UK.iso-8859-1/common.lang.php	(revision 649)
@@ -44,4 +44,5 @@
 $lang['picture'] = 'Picture';
 $lang['pictures'] = 'Pictures';
+$lang['name'] = 'Name';
 $lang['no'] = 'No';
 $lang['yes'] = 'Yes';
Index: trunk/language/fr_FR.iso-8859-1/common.lang.php
===================================================================
--- trunk/language/fr_FR.iso-8859-1/common.lang.php	(revision 648)
+++ trunk/language/fr_FR.iso-8859-1/common.lang.php	(revision 649)
@@ -44,4 +44,5 @@
 $lang['picture'] = 'Image';
 $lang['pictures'] = 'Images';
+$lang['name'] = 'Nom';
 $lang['no'] = 'Non';
 $lang['yes'] = 'Oui';
Index: trunk/template/default/admin/configuration.tpl
===================================================================
--- trunk/template/default/admin/configuration.tpl	(revision 648)
+++ trunk/template/default/admin/configuration.tpl	(revision 649)
@@ -103,4 +103,14 @@
 	<input type="radio" class="radio" name="show_nb_comments" value="false" {default.SHOW_COMMENTS_NO} />{L_NO}</td>
   </tr>
+  <tr>
+    <td><strong>{default.L_MAXWIDTH}&nbsp;:</strong></td>
+	<td><input type="text" size="4" maxlength="4" name="default_maxwidth" value="{default.MAXWIDTH}" />
+	</td>
+  </tr>
+	<tr>
+    <td><strong>{default.L_MAXHEIGHT}&nbsp;:</strong></td>
+	<td><input type="text" size="4" maxlength="4" name="default_maxheight" value="{default.MAXHEIGHT}" />
+	</td>
+  </tr>
 <!-- END default -->
 <!-- BEGIN upload -->