Index: trunk/admin/configuration.php
===================================================================
--- trunk/admin/configuration.php	(revision 650)
+++ trunk/admin/configuration.php	(revision 651)
@@ -163,6 +163,4 @@
   case 'general' :
   {
-    $access_free = ($conf['access']=='free')?'checked="checked"':'';
-    $access_restricted = ($conf['access']=='restricted')?'checked="checked"':'';
     $history_yes = ($conf['log']=='true')?'checked="checked"':'';
     $history_no  = ($conf['log']=='false')?'checked="checked"':'';
@@ -178,8 +176,4 @@
         'L_CONF_TN_PREFIX'=>$lang['conf_prefix'],
         'L_CONF_TN_PREFIX_INFO'=>$lang['conf_prefix_info'],
-        'L_CONF_ACCESS'=>$lang['conf_access'],
-        'L_CONF_ACCESS_INFO'=>$lang['conf_access_info'],
-        'L_CONF_ACCESS_FREE'=>$lang['free'],
-        'L_CONF_ACCESS_RESTRICTED'=>$lang['restricted'],
         'L_CONF_HISTORY'=>$lang['history'],
         'L_CONF_HISTORY_INFO'=>$lang['conf_log_info'],
@@ -189,6 +183,4 @@
         'ADMIN_MAIL'=>$conf['mail_webmaster'],
         'THUMBNAIL_PREFIX'=>$conf['prefix_thumbnail'],
-        'ACCESS_FREE'=>$access_free,
-        'ACCESS_RESTRICTED'=>$access_restricted,
         'HISTORY_YES'=>$history_yes,
         'HISTORY_NO'=>$history_no,
Index: trunk/identification.php
===================================================================
--- trunk/identification.php	(revision 650)
+++ trunk/identification.php	(revision 651)
@@ -96,10 +96,6 @@
   }
 }
-
 //-------------------------------------------------------------- visit as guest
-if ( $conf['access'] == 'free' )
-{
-  $template->assign_block_vars('free_access',array());
-}
+$template->assign_block_vars('free_access',array());
 //----------------------------------------------------------- html code display
 $template->pparse('identification');
Index: trunk/include/functions_user.inc.php
===================================================================
--- trunk/include/functions_user.inc.php	(revision 650)
+++ trunk/include/functions_user.inc.php	(revision 651)
@@ -159,14 +159,11 @@
 function check_login_authorization($guest_allowed = true)
 {
-  global $user,$lang,$conf,$page;
-
-  if ( $user['is_the_guest'])
-  {
-  if ( $conf['access'] == 'restricted' || !$guest_allowed )
+  global $user,$lang;
+
+  if ($user['is_the_guest'] and !$guest_allowed)
   {
     echo '<div style="text-align:center;">'.$lang['only_members'].'<br />';
     echo '<a href="./identification.php">'.$lang['ident_title'].'</a></div>';
     exit();
-  }
   }
 }
Index: trunk/index.php
===================================================================
--- trunk/index.php	(revision 650)
+++ trunk/index.php	(revision 651)
@@ -26,15 +26,6 @@
 // +-----------------------------------------------------------------------+
 
-//----------------------------------------------------------- include
 define('PHPWG_ROOT_PATH','./');
 include_once( PHPWG_ROOT_PATH.'include/common.inc.php' );
-if ( $conf['access'] == 'restricted' )
-{
-  if ( isset( $_COOKIE['id'] ) ) $url = 'category';
-  else                           $url = 'identification';
-}
-else                             $url = 'category';
-// redirection
-$url.= '.php';
-redirect( $url );
+redirect('category.php');
 ?>
Index: trunk/install/config.sql
===================================================================
--- trunk/install/config.sql	(revision 650)
+++ trunk/install/config.sql	(revision 651)
@@ -7,5 +7,4 @@
 INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('default_maxwidth','','maximum width authorized for displaying images');
 INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('default_maxheight','','maximum height authorized for the displaying images');
-INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('access','free','access type to your gallery (free|restricted)');
 INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('nb_comment_page','10','number of comments to display on each page');
 INSERT INTO phpwebgallery_config (param,value,comment) VALUES ('upload_maxfilesize','150','maximum filesize for the uploaded pictures');
Index: trunk/language/en_UK.iso-8859-1/admin.lang.php
===================================================================
--- trunk/language/en_UK.iso-8859-1/admin.lang.php	(revision 650)
+++ trunk/language/en_UK.iso-8859-1/admin.lang.php	(revision 651)
@@ -42,6 +42,4 @@
 $lang['authorized'] = 'Authorized';
 $lang['forbidden'] = 'Forbidden';
-$lang['free'] = 'Free';
-$lang['restricted'] = 'Restricted';
 $lang['public'] = 'public';
 $lang['private'] = 'private';
@@ -153,5 +151,4 @@
 $lang['conf_prefix_error'] = 'Thumbnail\'s prefix must only contain characters among : a to z (case insensitive), "-" or "_"';
 $lang['conf_access'] = 'Access type';
-$lang['conf_access_info'] = '- free : anyone can enter the site, any visitor can create an account in order to customize the appareance of the website<br />- restricted : the webmaster create accounts. Only registered users can enter the site';
 $lang['conf_log_info'] = 'Keep an history of visits on your website ? Visits will be shown in the history section of the administration panel';
 $lang['conf_notification'] = 'Mail notification';
Index: trunk/language/fr_FR.iso-8859-1/admin.lang.php
===================================================================
--- trunk/language/fr_FR.iso-8859-1/admin.lang.php	(revision 650)
+++ trunk/language/fr_FR.iso-8859-1/admin.lang.php	(revision 651)
@@ -42,6 +42,4 @@
 $lang['authorized'] = 'Autorisé';
 $lang['forbidden'] = 'Interdit';
-$lang['free'] = 'Libre';
-$lang['restricted'] = 'Restreint';
 $lang['public'] = 'Publique';
 $lang['private'] = 'Privée';
@@ -154,6 +152,4 @@
 $lang['conf_prefix_thumbnail_error'] = 'Le préfixe doit être uniquement composé des caractères suivant : a-z, "-" ou "_"';
 $lang['conf_access'] = 'Type d\'acces';
-$lang['conf_access_info'] = '- libre : n\'importe qui peut accéder à vos photos, tous les visiteurs peuvent se créer un compte pour pouvoir personnaliser l\'affichage<br />
-- restreint : l\'administrateur s\'occupe de créer des comptes, seuls les personnes membres peuvent accéder au site';
 $lang['conf_log_info'] = 'historiser les visites sur le site ? Les visites seront visibles dans l\'historique de l\'administration';
 $lang['conf_notification'] = 'Notification par mail';
Index: trunk/template/default/admin/configuration.tpl
===================================================================
--- trunk/template/default/admin/configuration.tpl	(revision 650)
+++ trunk/template/default/admin/configuration.tpl	(revision 651)
@@ -29,9 +29,4 @@
   </tr>
   <tr>
-  <td><strong>{general.L_CONF_ACCESS}&nbsp;:</strong><br /><span class="small">{general.L_CONF_ACCESS_INFO}</span></td>
-	<td class="row1"><input type="radio" class="radio" name="access" value="free" {general.ACCESS_FREE} />{general.L_CONF_ACCESS_FREE}&nbsp;&nbsp;
-	<input type="radio" class="radio" name="access" value="restricted" {general.ACCESS_RESTRICTED} />{general.L_CONF_ACCESS_RESTRICTED}</td>
-  </tr>
-  <tr>
     <td><strong>{general.L_CONF_HISTORY}&nbsp;:</strong><br /><span class="small">{general.L_CONF_HISTORY_INFO}</span></td>
 	<td class="row1"><input type="radio" class="radio" name="log" value="true" {general.HISTORY_YES} />{L_YES}&nbsp;&nbsp;