Index: trunk/language/en_UK.iso-8859-1/admin.lang.php
===================================================================
--- trunk/language/en_UK.iso-8859-1/admin.lang.php	(revision 654)
+++ trunk/language/en_UK.iso-8859-1/admin.lang.php	(revision 655)
@@ -229,4 +229,6 @@
 $lang['represents'] = 'represents';
 $lang['doesnt_represent'] = 'doesn\'t represent';
+$lang['waiting_update'] = 'Validated pictures will be displayed only once pictures database updated';
+$lang['cat_unknown_id'] = 'This category is unknown in the database';
 
 // Thumbnails
@@ -286,9 +288,10 @@
 $lang['stats_month_title'] = 'Monthly statistics';
 $lang['stats_pages_seen'] = 'Pages seen';
-$lang['stats_empty'] = 'empty history';
 $lang['stats_global_graph_title'] = 'Pages seen by month';
 $lang['stats_visitors_graph_title'] = 'Nombre de visiteurs par jour';
 
 // Users
+$lang['title_user_modify'] = 'Modify a user';
+$lang['title_user_perm'] = 'Modify permission for user';
 $lang['user_err_modify'] = 'This user can\'t be modified or deleted';
 $lang['user_err_unknown'] = 'This user doesn\'t exist in the database';
@@ -299,5 +302,5 @@
 $lang['user_delete'] = 'Delete user';
 $lang['user_delete_hint'] = 'Click here to delete this user. Warning! This operation cannot be undone!';
-
+$lang['permuser_only_private'] = 'Only private categories are shown';
 
 // Groups
@@ -312,38 +315,6 @@
 
 
-
-$lang['permuser_info_message'] = 'Permissions registered';
-$lang['permuser_title'] = 'Restrictions for user';
-$lang['permuser_warning'] = 'Warning : a "<span style="font-weight:bold;">forbidden access</span>" to the root of a category prevent from accessing the whole category';
-
-$lang['permuser_parent_forbidden'] = 'parent category forbidden';
-$lang['listuser_confirm'] = 'Do you really want to delete this user';
-$lang['listuser_info_deletion'] = 'was removed from database';
-$lang['listuser_user_group'] = 'Users group';
-$lang['listuser_modify'] = 'modify';
-$lang['listuser_modify_hint'] = 'modify informations of';
-$lang['listuser_permission'] = 'Permissions';
-$lang['listuser_permission_hint'] = 'modify permissions of';
-
-
-$lang['title_add'] = 'Add a user';
-$lang['title_modify'] = 'Modify a user';
-$lang['title_user_perm'] = 'Modify permission for user';
 $lang['title_cat_perm'] = 'Modify permissions for category';
 $lang['title_group_perm'] = 'Modify permissions for group';
 $lang['title_picmod'] = 'Modify informations about a picture';
-
-$lang['stats_pages_seen'] = 'pages seen';
-$lang['stats_visitors'] = 'guests';
-$lang['stats_empty'] = 'empty history';
-$lang['stats_pages_seen_graph_title'] = 'Number of pages seen by day';
-$lang['stats_visitors_graph_title'] = 'Number of guests by day';
-$lang['comments_last_title'] = 'Last comments';
-$lang['comments_non_validated_title'] = 'Comments waiting for validation';
-
-$lang['step1_err_copy'] = 'Copy the text between hyphens and paste it into the file "include/mysql.inc.php"(Warning : mysql.inc.php must only contain what is in blue, no line return or space character)';
-$lang['permuser_only_private'] = 'Only private categories are shown';
-$lang['waiting_update'] = 'Validated pictures will be displayed only once pictures database updated';
-$lang['cat_unknown_id'] = 'This category is unknown in the database';
-$lang['install_warning'] = 'The file "install.php" is still present. Please remove it from your server. It is not secure to keep it.';
 ?>
Index: trunk/language/fr_FR.iso-8859-1/admin.lang.php
===================================================================
--- trunk/language/fr_FR.iso-8859-1/admin.lang.php	(revision 654)
+++ trunk/language/fr_FR.iso-8859-1/admin.lang.php	(revision 655)
@@ -72,15 +72,15 @@
 $lang['remote_site_clean'] = 'clean';
 $lang['remote_site_clean_hint'] = 'remove remote listing.xml file';
-$lang['remote_site_delete'] = 'delete';
+$lang['remote_site_delete'] = 'Détruire';
 $lang['remote_site_delete_hint'] = 'delete this site and all its attached elements';
 $lang['remote_site_file_not_found'] = 'file create_listing_file.php on remote site was not found';
-$lang['remote_site_error'] = 'an error happened';
+$lang['remote_site_error'] = 'Une erreur est intervenue';
 $lang['remote_site_listing_not_found'] = 'remote listing file was not found';
 $lang['remote_site_removed'] = 'was removed on remote site';
 $lang['remote_site_removed_title'] = 'Removed elements';
-$lang['remote_site_created'] = 'created';
-$lang['remote_site_deleted'] = 'deleted';
+$lang['remote_site_created'] = 'Créé';
+$lang['remote_site_deleted'] = 'Détruit';
 $lang['remote_site_local_found'] = 'A local listing.xml file has been found for ';
-$lang['remote_site_local_new'] = '(new site)';
+$lang['remote_site_local_new'] = '(nouveau site)';
 $lang['remote_site_local_update'] = 'read local listing.xml and update';
 
@@ -230,5 +230,6 @@
 $lang['storage_category'] = 'Repertoire de stockage';
 $lang['represents'] = 'Représente';
-$lang['doesnt_represent'] = 'doesn\'t represent';
+$lang['doesnt_represent'] = 'Autres catégories';
+$lang['cat_unknown_id'] = 'Cette catégorie n\'existe pas dans la base de données';
 
 // Thumbnails
@@ -292,9 +293,10 @@
 $lang['stats_month_title'] = 'Historique mois par mois';
 $lang['stats_pages_seen'] = 'Pages vues';
-$lang['stats_empty'] = 'vider l\'historique';
 $lang['stats_global_graph_title'] = 'Nombre de pages vues par mois';
 $lang['stats_visitors_graph_title'] = 'Nombre de visiteurs par jour';
 
 // Users
+$lang['title_user_modify'] = 'Modifier un utilisateur';
+$lang['title_user_perm'] = 'Modifier les permissions pour l\'utilisateur';
 $lang['user_err_modify'] = 'Cet utilisateur ne peut pas être modifé ou supprimé';
 $lang['user_err_unknown'] = 'Cet utilisateur n\'existe pas dans la base de données';
@@ -305,4 +307,7 @@
 $lang['user_delete'] = 'Supprimer l\'utilisateur';
 $lang['user_delete_hint'] = 'Cliquez ici pour supprimer définitivement l\'utilisateur. Attention cette opération ne pourra être rétablie.';
+$lang['permuser_info'] = 'Seules les catégories déclarées en privée sont affichées. Cliquez ici pour y accéder : ';
+$lang['permuser_info_link'] = 'Sécurité des catégories';
+$lang['permuser_only_private'] = 'Seules les catégories privées sont représentées';
 
 // Groups
@@ -317,28 +322,8 @@
 
 
-// To be done
-
-
-$lang['permuser_info_message'] = 'Permissions enregistrées';
-$lang['permuser_title'] = 'Restrictions pour l\'utilisateur';
-$lang['permuser_warning'] = 'Attention : un "<span style="font-weight:bold;">accès interdit</span>" à la racine d\'une catégorie empêche l\'accès à toute la catégorie';
-$lang['permuser_parent_forbidden'] = 'catégorie parente interdite';
-
-
-
-
-$lang['title_add'] = 'Ajouter un utilisateur';
-$lang['title_modify'] = 'Modifier un utilisateur';
-
-$lang['title_user_perm'] = 'Modifier les permissions pour l\'utilisateur';
+
 $lang['title_cat_perm'] = 'Modifier les permissions pour la catégorie';
 $lang['title_group_perm'] = 'Modifier les permissions pour le groupe';
 $lang['title_picmod'] = 'Modifier les informations d\'une image';
 $lang['waiting_update'] = 'Les images validées ne seront visibles qu\'après mise à jour de la base d\'images.';
-$lang['permuser_only_private'] = 'Seules les catégories privées sont représentées';
-
-$lang['comments_last_title'] = 'Derniers commentaires';
-$lang['comments_non_validated_title'] = 'Commentaires non validés';
-$lang['cat_unknown_id'] = 'Cette catégorie n\'existe pas dans la base de données';
-$lang['conf_remote_site_delete_info'] = 'Supprimer un site revient à supprimer toutes les images et les catégories en relation avec ce site.';
 ?>